unit lines;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Contnrs, StdCtrls, ImgList, ExtCtrls, ComCtrls;

const min_cell=0;
      max_cell=7;

      cell_width=30;
      cell_height=30;

      total_rows=max_cell-min_cell+1;
      total_cols=total_rows;

      total_cell_count=((max_cell-min_cell+1)*(max_cell-min_cell+1));

      balls_to_destroy=4;

      //BALLS
      BALL_COUNT=8;


type
      TCell=record //    
        relations:array[1..4] of pinteger;//1=top_left 2=top_right 3=bottom_left 4=bottom_right

        locked:boolean;//   
        checked:boolean;//  

        bmp:integer;//  -1= 
      end;

      PInteger=^integer;
type
  TForm1 = class(TForm)
    Bmp_list: TImageList;
    Timer1: TTimer;
    Panel: TPanel;
    ProgressBar: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    Cells:array[0..total_cell_count-1] of TCell;//     
    Current_cell:integer;// 
    Dest_cell:integer;

    Stack:TStack;
    way:array of integer;
    mouse_down:boolean;

    bk:TBitmap;

    function TraceWay(Current,Dest:integer):boolean;
    function ConvertCoord2Num(Coord:TPoint):integer;
    function ConvertNum2Coord(num:integer):TPoint;
    procedure FillRelations;
    procedure ResetCells;

    procedure Put_ball(num:integer;ball:integer);overload;
    procedure Put_ball(Coord:TPoint;ball:integer);overload;
    procedure AddBalls;
    procedure Change_balls(Source,Dest:integer);
    procedure Check_balls(num:integer;add_balls:boolean);
    procedure NewGame;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

function TForm1.TraceWay(Current, Dest: integer): boolean;
  var i:integer;
      first:integer;
      min:integer;
  function trace:boolean;
  begin
    Result:=false;
    if (Cells[Current].relations[i]^<>-1)and//  
      (not Cells[Cells[Current].relations[i]^].locked)and//   
        (not Cells[Cells[Current].relations[i]^].checked) then//    
          begin
            if Cells[Current].relations[i]^-Dest<>0 then Stack.Push(Cells[Current].relations[i]);
            Result:=TraceWay(Cells[current].relations[i]^,dest);
            if not result then Stack.Pop;
          end;//if
  end;//trace

begin
  Result:=false;
  Cells[current].checked:=true;

  first:=1;
  min:=pinteger(Cells[Current].relations[1])^;
  if(Current-Dest>0) then for i:=1 to 4 do//   
    begin
      result:=trace;
      if result then break;
    end;

  first:=4;
  min:=1;
  if Current-Dest<0 then for i:=4 downto 1 do//   
    begin
      Result:=trace;
      if result then break;
    end;

    if Current-Dest=0 then
      begin
        Result:=true;
      end;//if Current-Dest=0
end;//TraceWay

procedure TForm1.FormCreate(Sender: TObject);
  var i:integer;
begin
  Stack:=Tstack.Create;
  FillRelations;
  Current_cell:=-1;

  ClientWidth:=cell_width*total_cols;
  ClientHeight:=total_rows*cell_height;

  Panel.Left:=(ClientWidth-Panel.Width) div 2;
  Panel.top:=(ClientHeight-Panel.Height) div 2;

  bk:=TBitmap.Create;
  bk.LoadFromFile('background.bmp');

  randomize;
  AddBalls;
end;

procedure TForm1.FillRelations;
  var x,y:integer;
      current:integer;
      i:integer;

      left,top,right,bottom:boolean;
begin
  for y:=min_cell to max_cell do
    for x:=min_cell to max_cell
      do
        begin
          current:=ConvertCoord2Num(Point(x,y));
          with Cells[current] do
            begin
              left:=x-1>=min_cell;
              top:=y-1>=min_cell;
              right:=x+1<=max_cell;
              bottom:=y+1<=max_cell;

              for i:=1 to 4 do new(relations[i]);

              if left then relations[2]^:=ConvertCoord2Num(Point(x-1,y))
                else Relations[2]^:=-1;
              if top then relations[1]^:=ConvertCoord2Num(Point(x,y-1))
                else relations[1]^:=-1;
              if right then relations[3]^:=ConvertCoord2Num(Point(x+1,y))
                else relations[3]^:=-1;
              if bottom then relations[4]^:=ConvertCoord2Num(Point(x,y+1))
                else relations[4]^:=-1;

              locked:=false;
              bmp:=-1;
            end;//with
        end;//for
end;

function TForm1.ConvertCoord2Num(Coord: TPoint): integer;
begin
  Result:=total_rows*Coord.Y+Coord.X;
end;

procedure TForm1.FormDestroy(Sender: TObject);
  var i,j:integer;
begin
  for i:=0 to total_cell_count-1 do
    for j:=1 to 4 do dispose(Cells[i].relations[j]);
  Stack.Free;
end;

procedure TForm1.ResetCells;
  var i:integer;
begin
  for i:=0 to total_cell_count-1 do Cells[i].checked:=false;
end;

procedure TForm1.FormPaint(Sender: TObject);
  var x,y:integer;
      bmp:TBitmap;
begin
  try
    bmp:=TBitMap.Create;
    Canvas.Lock;
    for y:=0 to total_rows-1 do
      for x:=0 to total_cols-1 do
        begin
          Canvas.Draw(x*cell_width,y*cell_height,bk);

          bmp_list.GetBitmap(Cells[ConvertCoord2Num(Point(x,y))].bmp,bmp);
          bmp.Transparent:=true;

          if ConvertCoord2Num(Point(x,y))=Current_cell then
            Canvas.Rectangle(x*cell_width+3,y*cell_height+3,x*cell_width-3+cell_width,y*cell_height-3+cell_height);
          if Cells[ConvertCoord2Num(Point(x,y))].bmp<>-1 then
            Canvas.Draw(x*cell_width+(cell_width-bmp.width) div 2, y*cell_height+(cell_height-bmp.height) div 2,bmp);
          //if Cells[ConvertCoord2Num(Point(x,y))].locked then Canvas.Rectangle(x*cell_width+10,y*cell_height+10,x*cell_width-10+cell_width,y*cell_height-10+cell_height);

        end;
    Canvas.Unlock;
  finally
    bmp.Free;
  end;
end;

procedure TForm1.Put_ball(num, ball: integer);
  var coord:TPoint;
      bmp:TBitmap;
begin
  Cells[num].bmp:=ball;
  coord:=ConvertNum2Coord(num);
  if ball=-1 then
    begin
      Cells[num].locked:=false;
      Canvas.Draw(coord.X*cell_width,coord.Y*cell_height,bk);
    end
      else
        begin
          Cells[num].locked:=true;
          try
            bmp:=TBitmap.Create;
            bmp_list.GetBitmap(ball,bmp);
            Canvas.Draw(coord.X*cell_width+(cell_width-bmp.width) div 2, coord.Y*cell_height+(cell_height-bmp.height) div 2,bmp);
          finally
            bmp.Free;
          end;//finally
        end;
  //Paint;
end;

procedure TForm1.Put_Ball(Coord: TPoint; ball: integer);
begin
  Cells[ConvertCoord2Num(Coord)].bmp:=ball;
    if ball=-1 then Cells[ConvertCoord2Num(Coord)].locked:=false
      else Cells[ConvertCoord2Num(Coord)].locked:=true;
  Paint;
end;

procedure TForm1.AddBalls;
  var i:integer;
      cell,ball:integer;
      free_cell_count:integer;
begin
  free_cell_count:=0;
  for i:=0 to total_cell_count-1 do
    if Cells[i].bmp=-1 then inc(free_cell_count);

  i:=0;
  while true do
    begin
      cell:=random(total_cell_count);
      ball:=random(BALL_COUNT);
      if not Cells[cell].locked then
        begin
          Put_ball(cell,ball);
          Check_balls(cell,false);
          Sleep(100);
          inc(i);
          dec(free_cell_count);
          if (free_cell_count=0)or(i=3) then break;
        end;
    end;
  if free_cell_count=0 then NewGame;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var cell_x, cell_y:integer;
    i:integer;
    temp:integer;
begin
  if Timer1.Enabled then exit;
  if mouse_down then exit;
  mouse_down:=true;
  cell_x:=x div cell_width;
  cell_y:=y div cell_height;

  if(Cells[ConvertCoord2Num(Point(cell_x,cell_y))].bmp<>-1) then
    begin
      if Current_cell=ConvertCoord2Num(Point(cell_x,cell_y)) then Current_cell:=-1
        else Current_cell:=ConvertCoord2Num(Point(cell_x,cell_y));
      Paint;
    end//if
      else
        begin
          if Current_cell<>-1 then
            begin
              Dest_cell:=ConvertCoord2Num(Point(cell_x,cell_y));
              if TraceWay(Current_cell,Dest_cell) then
                begin
                  temp:=Stack.Count+2;
                  SetLength(way,temp);
                  for i:=temp-2 downto 1 do way[i]:=pinteger(Stack.pop)^;
                  way[temp-1]:=Dest_cell;
                  way[0]:=Current_cell;
                  Timer1.Enabled:=true;
                end;//if
            end;
          ResetCells;
          Current_cell:=-1;
          Paint;
        end;//else
  mouse_down:=false;
end;

procedure TForm1.Change_balls(Source, Dest: integer);
begin
  Put_ball(Dest,Cells[Source].bmp);
  Put_ball(Source,-1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const i:integer=1;
var temp:integer;
begin
  Change_balls(way[i-1],way[i]);
  //Panel.Visible:=true;
  temp:=length(way);
  ProgressBar.Position:=i*100 div temp;
  inc(i);
  if i=length(way) then
    begin
      i:=1;
      Timer1.Enabled:=false;
      Panel.Visible:=false;
      Check_balls(way[length(way)-1],true);
      way:=nil;
    end;
end;

procedure TForm1.Check_balls(num: integer;add_balls:boolean);
  type ball_line=
      record
        count:integer;
        posit:TPoint;
      end;

  var cell_x,cell_y:integer;
      x,y:integer;
      i:integer;
      color:integer;
      balls:array of ball_line;
      ball:integer;
      max:integer;
begin
  with ConvertNum2Coord(num) do
    begin
      cell_x:=x;
      cell_y:=y;
    end;

    //
    color:=-1;
    ball:=-1;
    
    SetLength(balls,total_cols);
    for x:=0 to total_cols-1 do
      begin
        if (color=Cells[ConvertCoord2Num(Point(x,cell_y))].bmp)and(Cells[ConvertCoord2Num(Point(x,cell_y))].bmp<>-1) then
          begin
            inc(balls[ball].count);
          end
            else if Cells[ConvertCoord2Num(Point(x,cell_y))].bmp<>-1 then
              begin
                color:=Cells[ConvertCoord2Num(Point(x,cell_y))].bmp;
                inc(ball);
                balls[ball].count:=1;
                balls[ball].posit.X:=x;
              end
                else color:=-1;
      end;//for

      max:=0;
      for i:=1 to length(balls)-1 do
        if balls[max].count<balls[i].count then max:=i;
      if balls[max].count>=balls_to_destroy then
        begin
          for x:=balls[max].posit.X to balls[max].posit.X+balls[max].count-1 do
            begin
              Put_ball(ConvertCoord2Num(Point(x,cell_y)),-1);
              Sleep(100);
            end;
        end;

      //
      if balls[max].count<balls_to_destroy then
        begin
          balls:=nil;
          SetLength(balls,total_rows);

          color:=-1;
          ball:=-1;
          for y:=0 to total_rows-1 do
            begin
              if (color=Cells[ConvertCoord2Num(Point(cell_x,y))].bmp)and(Cells[ConvertCoord2Num(Point(cell_x,y))].bmp<>-1) then
                begin
                  inc(balls[ball].count);
                end
                  else if Cells[ConvertCoord2Num(Point(cell_x,y))].bmp<>-1 then
                    begin
                      color:=Cells[ConvertCoord2Num(Point(cell_x,y))].bmp;
                      inc(ball);
                      balls[ball].count:=1;
                      balls[ball].posit.Y:=y;
                    end
                      else color:=-1;
        end;//for

        max:=0;
        for i:=1 to length(balls)-1 do
          if balls[max].count<balls[i].count then max:=i;
        if balls[max].count>=balls_to_destroy then
          begin
            for y:=balls[max].posit.Y to balls[max].posit.Y+balls[max].count-1 do
              begin
                Put_ball(ConvertCoord2Num(Point(cell_x,y)),-1);
                Sleep(100);
              end;
          end;
      end;//if count<balls_to_destroy

      // \
      if balls[max].count<balls_to_destroy then
        begin
          color:=-1;
          ball:=-1;

          if cell_y>cell_x then
            begin
              x:=0;
              y:=cell_y-cell_x;
            end
              else
                begin
                  y:=0;
                  x:=cell_x-cell_y;
                end;

          balls:=nil;
          //   
          if(x=y) then SetLength(balls,total_rows)
            else if(x<y) then SetLength(balls,total_rows-y)
              else SetLength(balls,total_cols-x);
          while (y<total_rows)and(x<total_cols) do
            begin
              if (color=Cells[ConvertCoord2Num(Point(x,y))].bmp)and(Cells[ConvertCoord2Num(Point(x,y))].bmp<>-1) then
                begin
                  inc(balls[ball].count);
                end
                  else if Cells[ConvertCoord2Num(Point(x,y))].bmp<>-1 then
                    begin
                      color:=Cells[ConvertCoord2Num(Point(x,y))].bmp;
                      inc(ball);
                      balls[ball].count:=1;
                      balls[ball].posit:=point(x,y);
                    end
                      else color:=-1;
              inc(x);
              inc(y);
        end;//for

        max:=0;
        for i:=1 to length(balls)-1 do
          if balls[max].count<balls[i].count then max:=i;
        if balls[max].count>=balls_to_destroy then
            for i:=0 to balls[max].count-1 do
              begin
                Put_ball(ConvertCoord2Num(Point(balls[max].posit.x+i,balls[max].posit.Y+i)),-1);
                Sleep(100);
              end;
      end;//if count<balls_to_destroy

      // /
      if balls[max].count<balls_to_destroy then
        begin
          color:=-1;
          ball:=-1;

          x:=cell_x;
          y:=cell_y;
          while(true) do
            begin
              if(x=0)or(y=total_rows-1) then break;
              dec(x);
              inc(y);
            end;

          balls:=nil;
          if y<total_rows-x then SetLength(balls,y+1)
            else SetLength(balls,total_cols-x);

          while (y>=0)and(x<total_cols) do
            begin
              if (color=Cells[ConvertCoord2Num(Point(x,y))].bmp)and(Cells[ConvertCoord2Num(Point(x,y))].bmp<>-1) then
                begin
                  inc(balls[ball].count);
                end
                  else if Cells[ConvertCoord2Num(Point(x,y))].bmp<>-1 then
                    begin
                      color:=Cells[ConvertCoord2Num(Point(x,y))].bmp;
                      inc(ball);
                      balls[ball].count:=1;
                      balls[ball].posit:=point(x,y);
                    end
                      else color:=-1;
              inc(x);
              dec(y);
        end;//for

        max:=0;
        for i:=1 to length(balls)-1 do
          if balls[max].count<balls[i].count then max:=i;
        if balls[max].count>=balls_to_destroy then
            for i:=0 to balls[max].count-1 do
              begin
                Put_ball(ConvertCoord2Num(Point(balls[max].posit.x+i,balls[max].posit.Y-i)),-1);
                Sleep(100);
              end;
      end;//if count<balls_to_destroy}

  //Add_balls
  if add_balls and (balls[max].count<balls_to_destroy) then AddBalls;
  balls:=nil;
end;

function TForm1.ConvertNum2Coord(num: integer): TPoint;
  var x,y:integer;
begin
  y:=num div total_rows;
  x:=num-total_rows*y;
  Result:=Point(x,y);
end;

procedure TForm1.NewGame;
  var i:integer;
begin
  for i:=0 to total_cell_count-1 do Put_ball(i,-1);
  Current_cell:=-1;
  AddBalls;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  const ctrl:boolean=false;
begin
  if key=17 then ctrl:=true;
  if (key=78) and ctrl then
    begin
      ctrl:=false;
      NewGame;
    end;
end;

end.
